<template>
  <div id="optionsMenu" class="mainMenuOverlay floating2" :class="{ open: isActive }" ref="menuToggle">
  <div class="navire floating3"></div>
  <div class="itemMenuBox bills"><a class="itemMenu" v-on:click="openProject()">
      <i><font-awesome-icon :icon="['fas', 'th-large']" size="1x"/></i>
    </a></div>
  <div class="itemMenuBox tarsheed"><a class="itemMenu" v-on:click="previewCode()">
      <i><font-awesome-icon :icon="['fas', 'code']" size="1x"/></i>
    </a></div>
  <div class="itemMenuBox employees"><a class="itemMenu" v-on:click="openDocs()">
      <i><font-awesome-icon :icon="['fas', 'book-reader']" size="1x"/></i>
    </a></div>
  <div class="itemMenuBox location"><a href="javascript:void(0)" class="itemMenu ">
      <i><font-awesome-icon :icon="['fas', 'question']" size="1x"/></i>
    </a></div>
  <div class="itemMenuBox eservices"><a href="javascript:void(0)" class="itemMenu ">
      <i><font-awesome-icon :icon="['fas', 'info']" size="1x"/></i>
    </a></div>
  <div class="itemMenuBox contact"><a href="javascript:void(0)" class="itemMenu ">
      <i><font-awesome-icon :icon="['fas', 'microchip']" size="1x"/></i>
    </a></div>
  <a class="toggleMenu floating" v-on:click="openCloseMenu()">
    <i><font-awesome-icon :icon="['fas', 'bars']" size="1x"/></i>
  </a>
</div>
</template>

<script lang="ts">

/**
Código fuente original: Floating Circular Menu
Copyright (c) 2021 by Mahmoud (https://codepen.io/mahmoud-nb/pen/pbNBYP)

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit
persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/**
* Modificaciones y ajuste para Vue
* @author Johnny Cubides
*/

import { defineComponent, ref, onMounted } from 'vue'
import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome'
import { library } from '@fortawesome/fontawesome-svg-core'
import { faBars, faQuestion, faInfo, faBookReader, faCode, faMicrochip, faThLarge } from '@fortawesome/free-solid-svg-icons'
import BlocklyLang from 'blockly/lua'
import Blockly from 'blockly'

library.add(faBars)
library.add(faQuestion, faInfo, faBookReader, faCode, faMicrochip, faThLarge)
// import './blocks/stocks'
// import './prompt'

declare var Android: any // eslint-disable-line

export default defineComponent({
  components: {
    'font-awesome-icon': FontAwesomeIcon
  },
  emits: ['parentSendPreviewCode2Modal'],
  props: ['parentWorkspace'],
  // tslint:disable-next-line
  setup (props, context) { // eslint-disable-line
    let toggleReg = false
    const menuToggle = ref()

    const closeMenu = (): void => {
      toggleReg = false
      menuToggle.value.classList.remove('open')
    }

    const openCloseMenu = (): void => {
      if (toggleReg === false) {
        toggleReg = true
        menuToggle.value.classList.add('open')
      } else {
        closeMenu()
      }
    }

    const previewCode = (): void => {
      // (BlocklyLang as any).INFINITE_LOOP_TRAP = null // eslint-disable-line
      // console.log((BlocklyLang as any).workspaceToCode(props.parentWorkspace)) // eslint-disable-line
      context.emit('parentSendPreviewCode2Modal',
        (BlocklyLang as any).workspaceToCode(props.parentWorkspace)) // eslint-disable-line
    }

    const getXMLBlockly = (): string => {
      const xml = Blockly.Xml.workspaceToDom(props.parentWorkspace)
      return Blockly.Xml.domToText(xml)
    }

    const getCodeLua = (): string => {
      (BlocklyLang as any).INFINITE_LOOP_TRAP = null // eslint-disable-line
      return (BlocklyLang as any).workspaceToCode(props.parentWorkspace) // eslint-disable-line
    }

    const openDocs = (): void => {
      try {
        Android.startDocumentationActivity(getCodeLua(), getXMLBlockly())
      } catch (Error) {
        console.log('Android.startDocumentationActivity() failed: ', Error)
      }
    }

    const openProject = (): void => {
      try {
        Android.startProjectsActivity(getCodeLua(), getXMLBlockly())
      } catch (Error) {
        console.log('Android.startProjectsActivity() failed', Error)
      }
    }

    return {
      // Variables
      isActive: false,
      toggleReg,
      // Ref
      menuToggle,
      // Methods
      openCloseMenu,
      previewCode,
      getXMLBlockly,
      getCodeLua,
      openDocs,
      openProject
    }
  }
})
</script>

<style scoped>
/**
* se inhabilita el -moz estilo para mozilla ya que esto genera problemas en aplicaiones
* web, el comando aún no está estandarizado
* https://developer.mozilla.org/es/docs/Web/CSS/appearance
*/
/* @import url(https://fonts.googleapis.com/css?family=Source+Sans+Pro:200,300,400,600,700|Oswald:400,300,700);*/

body{background-color: rgba(218, 245, 255, 0.97);font-family: 'Oswald', sans-serif;}

.navire{
  /* background:url(https://res.cloudinary.com/dioieuprs/image/upload/v1471359656/navire_n02z6s.png) no-repeat; background-size:100% auto; width:120px; height:100px; position:absolute; top:-50px; right:-130px;-webkit-transition: right 0.2s ease; transition: right 0.2s ease; */
  background:url(../assets/floatingCircularMenu/navire_n02z6s.png) no-repeat; background-size:100% auto; width:120px; height:100px; position:absolute; top:-50px; right:-130px;-webkit-transition: right 0.2s ease; transition: right 0.2s ease;
}

.mainMenuOverlay.open .navire{right:70%;-webkit-transition: right 28s ease 1s; transition: right 28s ease 1s;}
/* ### main Menu Overlay */
.mainMenuOverlay {
  /* TODO STYLE */
  background-color: rgba(19, 28, 33, 1); /* rgba(34, 152, 195, 0.84); <-color original */
  position: fixed;left: 0;right: 0;bottom: -420px;z-index: 70;
  height: 420px;
  box-shadow: 0 0 15px -3px #03374A;
  border-radius: 100% 100% 0 0 / 14% 14% 0 0;
  -webkit-transition: bottom 0.5s ease; transition: bottom 0.5s ease;
}

.mainMenuOverlay.open { bottom: 0; }

.mainMenuOverlay .toggleMenu {
  display: block;
  /*background: url(https://res.cloudinary.com/dioieuprs/image/upload/v1466688705/floating-menu/sandwich.png) no-repeat center center #65B5D0;background-size: 23px auto;*/
  /*background: url(../assets/floatingCircularMenu/sandwich.png) no-repeat center center #65B5D0;background-size: 23px auto;*/
  /* TODO STYLE */
  background-color: #131C21; /* #65B5D0; <- color original */
  border: 1px solid #FFF; border-radius: 80px;
  width: 62px;height: 62px;
  position: absolute;top: -12px;left: 50%;
  margin: -31px 0 0 -31px;
  cursor: pointer;
  font-size:24px; color:#FFF; text-align:center; line-height:62px;
  box-shadow: 0 0 0 10px rgba(255, 255, 255, 0.2) inset, 0 0 16px -4px #063343;
  -webkit-transition: box-shadow 0.5s ease, top 0.5s ease; transition: box-shadow 0.5s ease, top 0.5s ease;
}

.mainMenuOverlay .toggleMenu:hover, .mainMenuOverlay .toggleMenu:active{}

.mainMenuOverlay.open .toggleMenu {
  /* TODO STYLE */
  top: 50%;
  background-color: #878787; /* #2298C3; <- color original */
}

.mainMenuOverlay .itemMenuBox {
  /* background: url(https://res.cloudinary.com/dioieuprs/image/upload/v1466688705/floating-menu/go2.png) no-repeat center center;background-size: 28px auto;*/
  background: url(../assets/floatingCircularMenu/go2.png) no-repeat center center;background-size: 28px auto;
  position: absolute; top: 50%; left: 50%;
  margin: -31px 0 0 -31px;
  height: 62px; width: 142px;
  text-align: right;
  border-radius: 40px;
  -webkit-transform-origin: 31px 31px;
  -ms-transform-origin: 31px 31px;
  transform-origin: 31px 31px;
  -webkit-transition: all 1s ease 0.4s;
  transition: all 1s ease 0.4s;
}

.mainMenuOverlay.open .itemMenuBox {width: 182px; -webkit-transition: all 1s ease 0s; transition: all 1s ease 0s;
}

.mainMenuOverlay .itemMenuBox.bills {-webkit-transform: rotate(270deg); -ms-transform: rotate(270deg); transform: rotate(270deg);
}

.mainMenuOverlay .itemMenuBox.tarsheed {-webkit-transform: rotate(330deg); -ms-transform: rotate(330deg); transform: rotate(330deg);
}

.mainMenuOverlay .itemMenuBox.employees {-webkit-transform: rotate(30deg); -ms-transform: rotate(30deg); transform: rotate(30deg);
}

.mainMenuOverlay .itemMenuBox.location {-webkit-transform: rotate(90deg); -ms-transform: rotate(90deg); transform: rotate(90deg);
}

.mainMenuOverlay .itemMenuBox.eservices {-webkit-transform: rotate(150deg); -ms-transform: rotate(150deg); transform: rotate(150deg);
}

.mainMenuOverlay .itemMenuBox.contact {-webkit-transform: rotate(210deg); -ms-transform: rotate(210deg); transform: rotate(210deg);
}

.mainMenuOverlay .itemMenuBox .itemMenu {
  display: inline-block;
  border: 2px solid rgba(255,255,255,0.6);
  border-radius: 40px;
  /* TODO STYLE */
  background-color: #878787; /* #1f97c2 <- color original */
  background-repeat: no-repeat;
  background-position: center center;
  width: 62px;height: 62px;
  border-radius: 40px;
  transition: all 0.8s ease;
  color:#FFF; font-size:28px; line-height:64px; text-align:center;
}

.mainMenuOverlay .itemMenuBox.bills .itemMenu {
	/*background-image: url(https://res.cloudinary.com/dioieuprs/image/upload/v1466688705/floating-menu/file.png);
	background-size: 20px auto;*/
	-webkit-transform: rotate(90deg);	-ms-transform: rotate(90deg);	transform: rotate(90deg);
}

.mainMenuOverlay .itemMenuBox.tarsheed .itemMenu {
	/* background-image: url(https://res.cloudinary.com/dioieuprs/image/upload/v1466688705/floating-menu/tarsheed.png);
	background-size: 38px auto;*/
	-webkit-transform: rotate(30deg);	-ms-transform: rotate(30deg);	transform: rotate(30deg);
}

.mainMenuOverlay .itemMenuBox.employees .itemMenu {
	/*background-image: url(https://res.cloudinary.com/dioieuprs/image/upload/v1466688705/floating-menu/employees.png);
	background-size: 38px auto;*/
	-webkit-transform: rotate(330deg);-ms-transform: rotate(330deg);transform: rotate(330deg);
}

.mainMenuOverlay .itemMenuBox.location .itemMenu {
	/*background-image: url(https://res.cloudinary.com/dioieuprs/image/upload/v1466688705/floating-menu/marker.png);
	background-size: 24px auto;*/
	-webkit-transform: rotate(270deg);	-ms-transform: rotate(270deg);	transform: rotate(270deg);
}

.mainMenuOverlay .itemMenuBox.eservices .itemMenu {
	/*background-image: url(https://res.cloudinary.com/dioieuprs/image/upload/v1466688705/floating-menu/mouse.png);
	background-size: 32px auto;*/
	-webkit-transform: rotate(210deg);	-ms-transform: rotate(210deg);	transform: rotate(210deg);
}

.mainMenuOverlay .itemMenuBox.contact .itemMenu {
	/*background-image: url(https://res.cloudinary.com/dioieuprs/image/upload/v1466688705/floating-menu/phone.png);
	background-size: 19px auto;*/
	-webkit-transform: rotate(150deg);	-ms-transform: rotate(150deg);	transform: rotate(150deg);
}

/* Hover */
.mainMenuOverlay .itemMenuBox.bills .itemMenu:hover {
    -webkit-transform: rotate(450deg);	-ms-transform: rotate(450deg);	transform: rotate(450deg);
}

.mainMenuOverlay .itemMenuBox.tarsheed .itemMenu:hover {
    -webkit-transform: rotate(390deg);	-ms-transform: rotate(390deg);	transform: rotate(390deg);
}

.mainMenuOverlay .itemMenuBox.employees .itemMenu:hover {
    -webkit-transform: rotate(690deg);	-ms-transform: rotate(690deg);	transform: rotate(690deg);
}

.mainMenuOverlay .itemMenuBox.location .itemMenu:hover {
    -webkit-transform: rotate(630deg);	-ms-transform: rotate(630deg);	transform: rotate(630deg);
}

.mainMenuOverlay .itemMenuBox.eservices .itemMenu:hover {
    -webkit-transform: rotate(570deg);	-ms-transform: rotate(570deg);	transform: rotate(570deg);
}

.mainMenuOverlay .itemMenuBox.contact .itemMenu:hover {
    -webkit-transform: rotate(510deg);	-ms-transform: rotate(510deg);	transform: rotate(510deg);
}

.floating{
    -webkit-animation-name: Floatingx;
    -webkit-animation-duration: 3s;
    -webkit-animation-iteration-count: infinite;
    -webkit-animation-timing-function: ease-in-out;
    /*-moz-animation-name: Floating;
    -moz-animation-duration: 3s;
    -moz-animation-iteration-count: infinite;
    -moz-animation-timing-function: ease-in-out;*/
}

@-webkit-keyframes Floatingx{
    from {-webkit-transform:translate(0, 0px);}
    65% {-webkit-transform:translate(0, 5px);}
    to {-webkit-transform: translate(0, -0px);    }
}

@-moz-keyframes Floating{
    from {-moz-transform:translate(0, 0px);}
    65% {-moz-transform:translate(0, 5px);}
    to {-moz-transform: translate(0, -0px);}
}

.floating2{
    -webkit-animation-name: Floatingx2;
    -webkit-animation-duration: 3s;
    -webkit-animation-iteration-count: infinite;
    -webkit-animation-timing-function: ease-in-out;
    /*-moz-animation-name: Floating2;
    -moz-animation-duration: 3s;
    -moz-animation-iteration-count: infinite;
    -moz-animation-timing-function: ease-in-out;
    */
}

@-webkit-keyframes Floatingx2{
    from {-webkit-transform:translate(0, 0px);}
    45% {-webkit-transform:translate(0, 8px);}
    to {-webkit-transform: translate(0, -0px);    }
}

@-moz-keyframes Floating2{
    from {-moz-transform:translate(0, 0px);}
    45% {-moz-transform:translate(0, 8px);}
    to {-moz-transform: translate(0, -0px);}
}

.floating3{
    -webkit-animation-name: Floatingx3;
    -webkit-animation-duration: 3s;
    -webkit-animation-iteration-count: infinite;
    -webkit-animation-timing-function: ease-in-out;
    /*-moz-animation-name: Floating3;
    -moz-animation-duration: 3s;
    -moz-animation-iteration-count: infinite;
    -moz-animation-timing-function: ease-in-out;*/
}

@-webkit-keyframes Floatingx3{
    from {-webkit-transform:translate(0, 0px);}
    50% {-webkit-transform:translate(2px, 4px);}
    to {-webkit-transform: translate(0, -0px);    }
}

@-moz-keyframes Floating3{
  from {-moz-transform:translate(0, 0px);}
  50% {-moz-transform:translate(2px, 4px);}
  to {-moz-transform: translate(0, -0px);}
}

/* signature */
/* .signatureBox{text-align:right; padding:4px;}
.signatureBox.fixed{ position:fixed; bottom:8px; right:8px; }
.signature, .signature a{color:#484848; }
.signature:before, .signature:after{ display:inline-block; overflow:hidden; vertical-align: bottom; -webkit-transition: all 0.5s; -webkit-transition: all 0.5s; width:11px}
.signature:before{content:'Mahmoud';}
.signature:after{content:'NBET'; margin-left:0px;width:10px}

.signature:hover{color:#484848;}
.signature:hover:before{width:76px;}
.signature:hover:after{width:34px; margin-left:3px;}*/
</style>
